import Component from '@glimmer/component';
import { type CellColumnSummarySignature } from '../../../../interfaces/components/models-table/themes/default/cell-column-summary-signature.interface';
/**
 * Component for table-footer cells. Used as column-summary.
 *
 * It yields several properties:
 *
 * * {@link DefaultTheme.CellColumnSummary.minSelected | minSelected}
 * * {@link DefaultTheme.CellColumnSummary.maxSelected | maxSelected}
 * * {@link DefaultTheme.CellColumnSummary.sumSelected | sumSelected}
 * * {@link DefaultTheme.CellColumnSummary.avgSelected | avgSelected}
 * * {@link DefaultTheme.CellColumnSummary.medianSelected | medianSelected}
 * * {@link DefaultTheme.CellColumnSummary.minData | minData}
 * * {@link DefaultTheme.CellColumnSummary.maxData | maxData}
 * * {@link DefaultTheme.CellColumnSummary.sumData | sumData}
 * * {@link DefaultTheme.CellColumnSummary.avgData | avgData}
 * * {@link DefaultTheme.CellColumnSummary.medianData | medianData}
 *
 * Component should be used only for column with set `propertyName`.
 *
 * Component should be extended.
 */
export default class CellColumnSummary extends Component<CellColumnSummarySignature> {
    /**
     * Min of mapped `selectedItems`
     */
    get minSelected(): number | null;
    /**
     * Min of mapped `data`
     */
    get minData(): number | null;
    /**
     * Max of mapped `selectedItems`
     */
    get maxSelected(): number | null;
    /**
     * Max of mapped `data`
     */
    get maxData(): number | null;
    /**
     * Sum of mapped `selectedItems`
     */
    get sumSelected(): number;
    /**
     * Sum of mapped `data`
     */
    get sumData(): number;
    /**
     * Average of mapped `selectedItems`
     */
    get avgSelected(): number;
    /**
     * Average of mapped `data`
     */
    get avgData(): number;
    /**
     * Median of mapped `selectedItems`
     */
    get medianSelected(): number | null;
    /**
     * Median of mapped `data`
     */
    get medianData(): number | null;
}
//# sourceMappingURL=cell-column-summary.d.ts.map