import Component from '@glimmer/component';
import { type ExpandToggleSignature } from '../../../../interfaces/components/models-table/themes/default/expand-toggle-signature.interface';
/**
 * Component to expand or collapse any single row
 *
 * Usage example:
 *
 * ```js
 * const columns = [
 *   {
 *     component: 'models-table/themes/default/expand-toggle',
 *     mayBeHidden: false
 *   },
 *   {propertyName: 'firstName'},
 *   {propertyName: 'lastName'}
 * ];
 *
 * const data = [ ... ];
 * ```
 *
 * ```html
 * <ModelsTable
 *   @data={{this.data}}
 *   @columns={{this.columns}}
 *   @expandedRowComponent={{component "path/to/your-component"}}
 * />
 * ```
 */
export default class ExpandToggle extends Component<ExpandToggleSignature> {
    /**
     * @event doCollapseRow
     */
    protected doCollapseRow(e: Event): boolean;
    /**
     * @event doExpandRow
     */
    protected doExpandRow(e: Event): boolean;
}
//# sourceMappingURL=expand-toggle.d.ts.map