import { type ComponentLike } from '@glint/template';
import Component from '@glimmer/component';
import { type RowGroupingSignature } from '../../../../interfaces/components/models-table/themes/default/row-grouping-signature.interface';
import { type RowGroupToggleSignature } from '../../../../interfaces/components/models-table/themes/default/row-group-toggle-signature.interface';
import { type ModelsTableDataItem } from '../../../../types/models-table-data-item.type';
/**
 * Component-row with grouped property value. Used to toggle rows group with needed property value equal to the grouping value.
 *
 * You must not override this component and should use {@link Core.ModelsTable.groupingRowComponent | ModelsTable.groupingRowComponent}.
 *
 * By default {@link DefaultTheme.RowGroupToggle} is used
 */
export default class RowGrouping extends Component<RowGroupingSignature> {
    protected get cellColspan(): number;
    protected get selectedGroupedItems(): ModelsTableDataItem[];
    protected get expandedGroupedItems(): ModelsTableDataItem[];
    protected get rowGroupToggleComponent(): ComponentLike<RowGroupToggleSignature> | ComponentLike;
}
//# sourceMappingURL=row-grouping.d.ts.map