import { type ComponentLike } from '@glint/template';
import Bootstrap3Theme from './bootstrap3';
import { type ColumnsDropdownSignature } from '../../interfaces/components/models-table/themes/default/columns-dropdown-signature.interface';
import { type DataGroupBySelectSignature } from '../../interfaces/components/models-table/themes/default/data-group-by-select-signature.interface';
import { type GlobalFilterSignature } from '../../interfaces/components/models-table/themes/default/global-filter-signature.interface';
import { type RowFilteringCellSignature } from '../../interfaces/components/models-table/themes/default/row-filtering-cell-signature.interface';
export default class Bootstrap4Theme extends Bootstrap3Theme {
    /**
     * @default 'models-table/themes/bootstrap4/columns-dropdown'
     */
    get columnsDropdownComponent(): ComponentLike<ColumnsDropdownSignature>;
    /**
     * @default 'models-table/themes/bootstrap4/data-group-by-select'
     */
    get dataGroupBySelectComponent(): ComponentLike<DataGroupBySelectSignature>;
    /**
     * @default 'models-table/themes/bootstrap4/global-filter'
     */
    get globalFilterComponent(): ComponentLike<GlobalFilterSignature>;
    /**
     * @default 'models-table/themes/bootstrap4/row-filtering-cell'
     */
    get rowFilteringCellComponent(): ComponentLike<RowFilteringCellSignature>;
    table: string;
    globalFilterWrapper: string;
    columnsDropdown: string;
    columnsDropdownWrapper: string;
    columnsDropdownDivider: string;
    buttonDefault: string;
    get buttonDefaultSmall(): string;
    footerSummaryNumericPagination: string;
    footerSummaryDefaultPagination: string;
    pageSizeWrapper: string;
    pageSizeSelectWrapper: string;
    paginationInternalWrapper: string;
    paginationWrapperNumeric: string;
    paginationWrapperDefault: string;
    clearFilterIcon: string;
    clearAllFiltersIcon: string;
    sortGroupedPropertyBtn: string;
    input: string;
    inputGroup: string;
    sortAscIcon: string;
    sortDescIcon: string;
    columnVisibleIcon: string;
    columnHiddenIcon: string;
    navFirstIcon: string;
    navPrevIcon: string;
    navNextIcon: string;
    navLastIcon: string;
    caretIcon: string;
    expandRowIcon: string;
    expandAllRowsIcon: string;
    collapseRowIcon: string;
    collapseAllRowsIcon: string;
    selectAllRowsIcon: string;
    deselectAllRowsIcon: string;
    selectSomeRowsIcon: string;
    selectRowIcon: string;
    deselectRowIcon: string;
}
declare module '@ember/service' {
    interface Registry {
        'emt-themes/bootstrap4': Bootstrap4Theme;
    }
}
//# sourceMappingURL=bootstrap4.d.ts.map